package com.bonus.sgzb.material.service;

import com.bonus.sgzb.material.domain.*;
import com.bonus.sgzb.material.vo.ForecastWasteExcel;
import com.bonus.sgzb.material.vo.ScrapApplyDetailsVO;
import com.bonus.sgzb.material.vo.ScrapAudit;

import java.util.List;

/**
 * 报废任务详细scrap_apply_detailsService接口
 * 
 * @author bonus
 * @date 2023-12-15
 */
public interface IScrapApplyDetailsService 
{
    /**
     * 查询报废任务详细scrap_apply_details
     * 
     * @param id 报废任务详细scrap_apply_details主键
     * @return 报废任务详细scrap_apply_details
     */
    public ScrapApplyDetails selectScrapApplyDetailsById(Long id);

    /**
     * 查询报废任务详细scrap_apply_details列表
     * 
     * @param scrapApplyDetails 报废任务详细scrap_apply_details
     * @return 报废任务详细scrap_apply_details集合
     */
    public List<ScrapApplyDetailsVO> selectScrapApplyDetailsList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 新增报废任务详细scrap_apply_details
     * 
     * @param scrapApplyDetails 报废任务详细scrap_apply_details
     * @return 结果
     */
    public int insertScrapApplyDetails(ScrapApplyDetails scrapApplyDetails);

    /**
     * 修改报废任务详细scrap_apply_details
     * 
     * @param scrapApplyDetails 报废任务详细scrap_apply_details
     * @return 结果
     */
    public int updateScrapApplyDetails(ScrapApplyDetails scrapApplyDetails);

    /**
     * 批量删除报废任务详细scrap_apply_details
     * 
     * @param ids 需要删除的报废任务详细scrap_apply_details主键集合
     * @return 结果
     */
    public int deleteScrapApplyDetailsByIds(Long[] ids);

    /**
     * 删除报废任务详细scrap_apply_details信息
     * 
     * @param id 报废任务详细scrap_apply_details主键
     * @return 结果
     */
    public int deleteScrapApplyDetailsById(Long id);

    /**
     * 查看报废任务详细列表
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapApplyDetails> getScrapAuditList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 报废任务审核
     * @param scrapAudit
     * @return
     * @throws Exception
     */
    int auditScrap(ScrapAudit scrapAudit) throws Exception;

    /**
     * 导出报废任务列表
     * @param bean
     * @return
     */
    List<ScrapApplyDetailsVO> exportScrapApplyDetailsList(ScrapApplyDetails bean);

    List<RepairRecord> getScrapRecord(ScrapApplyDetails scrapApplyDetails);

    List<String> getFileUrl(String fileIds);

    /**
     * 获取预报废申请列表。
     *
     * @param scrapApplyDetails 包含预报废申请详情的实体对象，用于筛选申请列表的条件。
     * @return 返回一个预报废申请详情的VO（值对象）列表，这些对象代表了满足条件的预报废申请的详细信息。
     */
    List<ScrapApplyDetailsVO> getScrapApplyList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 预报废申请审核
     * @param scrapAudit
     * @return
     * @throws Exception
     */
    int forecastWasteAudit(ScrapAudit scrapAudit);

    /**
     * 提交废弃任务审计信息。
     *
     * @param scrapAudit 包含废弃任务审计信息的对象。
     * @return 返回任务提交的结果，通常为任务的ID或状态码。
     */
    int submitScrapTask(ScrapAudit scrapAudit);

    /**
     * 废弃任务审核----宁夏
     * @param scrapAuditorSet
     * @return
     */
    int scrapTaskReview(ScrapAuditorSet scrapAuditorSet);

    /**
     * 报废任务审核列表
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapApplyDetailsVO> scrapTaskReviewList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 获取处置列表----宁夏
     * @param scrapApplyDetails
     * @return
     */
    List<ScrapApplyDetailsVO> obtainDisposalList(ScrapApplyDetails scrapApplyDetails);

    /**
     * 处置----宁夏
     * @param tmTaskList
     * @return
     */
    int obtainDisposal(List<TmTask> tmTaskList);

    /**
     * 导出预报废审核列表
     * @param scrapApplyDetails
     * @return
     */
    List<ForecastWasteExcel> exportForecastWaste(ScrapApplyDetails scrapApplyDetails);
}
